import os,scipy.interpolate,sys,scipy.signal
import numpy as np
from astropy.io import fits

# make some kind of kernel, there are many ways to do this...
#    t = 1 - np.abs(np.linspace(-1, 1, 21))
#    kernel = t.reshape(21, 1) * t.reshape(1, 21)
#    kernel /= kernel.sum()   # kernel should sum to 1!  :) 

#    a=np.linspace(3,2043,205)
#    b=np.linspace(0,0,205)
x=np.linspace(0,2047,2048)
y=np.linspace(0,0,2048)

os.system('ls d7095.*.fits > fits.lst')

for line in open("fits.lst"):
    line=line.strip("\n")

    object=fits.open(line)
    print(line),fits.getval(line,'IMAGETYP',0)

    for k in range(16):
        data=object[k+1].data
        for i in range(2048):
            xmedian=np.median(data[i,2016:2036])
            y[i]=xmedian

        c=scipy.interpolate.UnivariateSpline(x,y)
        c.set_smoothing_factor(8000)
#        c=scipy.interpolate.InterpolatedUnivariateSpline(x,y)
#        c.set_smoothing_factor(smooth)

#        print k+1,np.std(data[1410:1590,210:390])
        for i in range(2048):
            data[i,:2016]-=c(i)

#        data=scipy.signal.convolve2d(data, kernel, mode='same')
        object[k+1].data=data

#        plt.plot(x,y,'r',lw=1)
#        plt.plot(x,c(x),'b',lw=2)
#        plt.axis([0,2050,np.median(y)-10,np.median(y)+10])
#        plt.show()
#        raw_input()    

    line1=line.replace('d','e')

    object.writeto(line1[:15],clobber='Ture')
    object.close()
